return function(peerType, callback)
  local Context = require("silo.context")

  local ctx = Context()
  ctx.bus:handleOSEvents(ctx)

  local messaging = ctx:require("silo.messaging")
  local protocol = ctx:require("silo.protocol")
  local taskQueue = ctx:require("silo.task_queue")

  messaging:open()

  taskQueue:enqueue(function()
    protocol:announce(peerType)
  end)

  xpcall(
    function()
      callback(ctx)
    end,

    function(err)
      print(err)
    end
  )

  messaging:send({ type = "terminating" })
  messaging:close()

  ctx.config:save()
end
